
; ========================================================
;			
;    -- Graph.asm --
;			Jay Sullivan
; ========================================================
  
.486
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include Graph.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
		CeeOfExWye PROTO
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND


	;------------------------------------------------
	;	Main Window Class
	;------------------------------------------------
		
		mov wc.cbSize, Sizeof WNDCLASSEX
		mov wc.style, CS_HREDRAW or CS_VREDRAW
		mov wc.lpfnWndProc, Offset WndProc
		mov wc.cbClsExtra,NULL
		mov wc.cbWndExtra,NULL
		mov eax,hInst
		mov wc.hInstance,eax
		mov wc.hbrBackground, COLOR_WINDOW+1
		mov wc.lpszMenuName, NULL
		mov wc.lpszClassName, Offset ClassName
		invoke LoadIcon, NULL, IDI_APPLICATION
		mov wc.hIcon,eax
		mov wc.hIconSm,0
		invoke LoadCursor, NULL, IDC_ARROW
		mov wc.hCursor,eax
		invoke RegisterClassEx, ADDR wc
		
	;------------------------------------------------
	;	Windows
	;------------------------------------------------
		
		;-----------------------------
		;	Main Window
		;-----------------------------
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW,\
				CW_USEDEFAULT,CW_USEDEFAULT,550,550,\
				NULL,0,hInst,NULL
			mov hwnd,eax
				
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP

;------------------------------------------------
;	WndProc
;------------------------------------------------
align 8
.data?
CUR_X REAL8 ?
CUR_Y REAL8 ?

CUR_X_int dd ?
CUR_Y_int dd ?

CUR_COLOR dd ?

Y_MIN dd ?
Y_MAX dd ?

X_MIN dd ?
X_MAX dd ?

WINDOW_WIDTH dd ?
WINDOW_HEIGHT dd ?

ps PAINTSTRUCT <>
myBitmapInfo BITMAPINFO <>
hdcMem HDC ?
hBitmap HBITMAP ?
pvBits dd ?
.code

WM_CREATEIMAGE equ WM_USER+1
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL hBrush:HBRUSH, hPen:HPEN,
	  hdc:HDC, myRect:RECT
	;-----------------------------
	 .if uMsg==WM_DESTROY
	;-----------------------------
		
        invoke DeleteDC,hdcMem
        invoke DeleteDC,hdc
		invoke PostQuitMessage, NULL
		

	;-----------------------------
	 .elseif uMsg==WM_CREATE
	;-----------------------------
	
	
		mov WINDOW_HEIGHT, 500
		mov WINDOW_WIDTH, 500
		
		mov X_MIN, -250
		mov X_MAX, 250
		mov Y_MIN, -250
		mov Y_MAX, 250
		
		invoke PostMessage,hWnd,WM_CREATEIMAGE,0,0
		xor eax,eax
		
	;-----------------------------
	 .elseif uMsg==WM_CREATEIMAGE
	;-----------------------------
	
		
		
	  invoke GetDC,hWnd
	  mov hdc, eax
	  
	  
	  invoke CreateCompatibleDC,hdc
	  mov hdcMem, eax
	  invoke CreateCompatibleBitmap,hdc,WINDOW_WIDTH,WINDOW_HEIGHT
	  mov hBitmap, eax
	  invoke SelectObject,hdcMem,hBitmap
	  
	;-------------------------------------------------------
	; Start drawing bitmap
	;-------------------------------------------------------
	  
	  
	  
		invoke SetMapMode,hdcMem,MM_ANISOTROPIC
		invoke SetViewportOrgEx,hdcMem,X_MAX,Y_MAX,0
		;-----------------------------
		; Draw
		;-----------------------------
		
		;-----------------------------
		; Grid
		;-----------------------------
			invoke CreatePen,PS_SOLID,1,0FF00h
			mov hPen, eax
			invoke SelectObject,hdcMem,hPen
			invoke Rectangle,hdcMem,X_MIN,Y_MIN,X_MAX,Y_MAX
			invoke Rectangle,hdcMem,-100,-100,100,100
		;-----------------------------
		; Graph
		;-----------------------------
			finit
			
		;-----------------------------
		; Rows
		;-----------------------------
			fild Y_MIN
			fst CUR_Y
			fistp CUR_Y_int
		nextrow:
			
			
				;-----------------------------
				; Columns
				;-----------------------------
					fild X_MIN
					fst CUR_X
					fistp CUR_X_int
				nextcolumn:
					invoke CeeOfExWye			
					invoke SetPixel,hdcMem,CUR_X_int,CUR_Y_int,CUR_COLOR
					
					fld $float(0.5) ; st(0)
					fadd CUR_X      ; st(0)
					fst  CUR_X      ; st(0)
					fistp CUR_X_int      ; st(0)
					mov eax, CUR_X_int
					cmp eax, X_MAX
					jl nextcolumn       ;
				
				
			fld $float(1.0)            ; st(0)
			fadd CUR_Y      ; st(0)
			fst  CUR_Y      ; st(0)
			fistp CUR_Y_int      ; st(0)
			mov eax, CUR_Y_int
			cmp eax, Y_MAX
			jl nextrow       ;
			
			
		;-----------------------------
		; Setdown
		;-----------------------------
		
		invoke DeleteObject,hPen
	  
			
	;-------------------------------------------------------
	; Done drawing bitmap
	;-------------------------------------------------------
	  
	  
	  
	  invoke ReleaseDC,hWnd,hdcMem
	  invoke InvalidateRect,hWnd,0,FALSE
	
	;-----------------------------
	 .elseif uMsg==WM_SIZE
	;-----------------------------
	
	  movzx eax, HIWORD(lParam)
	  movzx ecx, LOWORD(lParam)
	  mov WINDOW_HEIGHT, eax
	  mov WINDOW_WIDTH, ecx
	  
	  sar eax, 1
	  sar ecx, 1
	  mov Y_MAX, eax
	  mov X_MAX, ecx
	  neg eax
	  neg ecx
	  mov X_MIN, eax
	  mov Y_MIN, ecx
	  
	  
	  
	  
	;-----------------------------
	 .elseif uMsg==WM_ERASEBKGND
	;-----------------------------
	mov eax, 1
	;-----------------------------
	 .elseif uMsg==WM_PAINT
	;-----------------------------
	
		;-----------------------------
		; Setup
		;-----------------------------
	
	
		invoke BeginPaint,hWnd, Offset ps
		mov hdc, eax
		;invoke SetViewportOrgEx,hdc,X_MAX,Y_MAX,0
	  
		invoke SetMapMode,hdcMem,MM_ANISOTROPIC
		;invoke SetViewportOrgEx,hdcMem,X_MAX,Y_MAX,0
		
		invoke StretchBlt,hdc,0,0,WINDOW_WIDTH,WINDOW_HEIGHT,hdcMem,-250,-250,500,500,SRCCOPY
		;invoke StretchBlt,hdc,X_MIN,Y_MIN,WINDOW_WIDTH,WINDOW_HEIGHT,hdcMem,X_MIN,Y_MIN,250,250,SRCCOPY
		
        invoke EndPaint,hWnd, Offset ps
        
		
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP


CeeOfExWye PROC
LOCAL temp:DWORD

	fld CUR_X
	
	
	fst st(1)
	fmul
	fsub $float(0.75)
	
	
	fmul CUR_Y
	fmul CUR_X
	fadd $float(1.1)
	
	fsqrt
	
	
	
	
	fistp CUR_COLOR
	ret
CeeOfExWye ENDP

End Start